Index: /trunk/include/phonon/abstractaudiooutput.h
===================================================================
--- /trunk/include/phonon/abstractaudiooutput.h	(revision 560)
+++ /trunk/include/phonon/abstractaudiooutput.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../src/phonon/../3rdparty/phonon/phonon/abstractaudiooutput.h"
Index: /trunk/include/phonon/abstractmediastream.h
===================================================================
--- /trunk/include/phonon/abstractmediastream.h	(revision 560)
+++ /trunk/include/phonon/abstractmediastream.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../src/phonon/../3rdparty/phonon/phonon/abstractmediastream.h"
Index: /trunk/include/phonon/abstractvideooutput.h
===================================================================
--- /trunk/include/phonon/abstractvideooutput.h	(revision 560)
+++ /trunk/include/phonon/abstractvideooutput.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../src/phonon/../3rdparty/phonon/phonon/abstractvideooutput.h"
Index: /trunk/include/phonon/addoninterface.h
===================================================================
--- /trunk/include/phonon/addoninterface.h	(revision 560)
+++ /trunk/include/phonon/addoninterface.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../src/phonon/../3rdparty/phonon/phonon/addoninterface.h"
Index: /trunk/include/phonon/audiooutput.h
===================================================================
--- /trunk/include/phonon/audiooutput.h	(revision 560)
+++ /trunk/include/phonon/audiooutput.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../src/phonon/../3rdparty/phonon/phonon/audiooutput.h"
Index: /trunk/include/phonon/audiooutputinterface.h
===================================================================
--- /trunk/include/phonon/audiooutputinterface.h	(revision 560)
+++ /trunk/include/phonon/audiooutputinterface.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../src/phonon/../3rdparty/phonon/phonon/audiooutputinterface.h"
Index: /trunk/include/phonon/backendcapabilities.h
===================================================================
--- /trunk/include/phonon/backendcapabilities.h	(revision 560)
+++ /trunk/include/phonon/backendcapabilities.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../src/phonon/../3rdparty/phonon/phonon/backendcapabilities.h"
Index: /trunk/include/phonon/backendinterface.h
===================================================================
--- /trunk/include/phonon/backendinterface.h	(revision 560)
+++ /trunk/include/phonon/backendinterface.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../src/phonon/../3rdparty/phonon/phonon/backendinterface.h"
Index: /trunk/include/phonon/effect.h
===================================================================
--- /trunk/include/phonon/effect.h	(revision 560)
+++ /trunk/include/phonon/effect.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../src/phonon/../3rdparty/phonon/phonon/effect.h"
Index: /trunk/include/phonon/effectinterface.h
===================================================================
--- /trunk/include/phonon/effectinterface.h	(revision 560)
+++ /trunk/include/phonon/effectinterface.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../src/phonon/../3rdparty/phonon/phonon/effectinterface.h"
Index: /trunk/include/phonon/effectparameter.h
===================================================================
--- /trunk/include/phonon/effectparameter.h	(revision 560)
+++ /trunk/include/phonon/effectparameter.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../src/phonon/../3rdparty/phonon/phonon/effectparameter.h"
Index: /trunk/include/phonon/effectwidget.h
===================================================================
--- /trunk/include/phonon/effectwidget.h	(revision 560)
+++ /trunk/include/phonon/effectwidget.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../src/phonon/../3rdparty/phonon/phonon/effectwidget.h"
Index: /trunk/include/phonon/headers.pri
===================================================================
--- /trunk/include/phonon/headers.pri	(revision 560)
+++ /trunk/include/phonon/headers.pri	(revision 560)
@@ -0,0 +1,2 @@
+SYNCQT.HEADER_FILES = ../phonon/../3rdparty/phonon/phonon/abstractaudiooutput.h ../phonon/../3rdparty/phonon/phonon/abstractmediastream.h ../phonon/../3rdparty/phonon/phonon/abstractvideooutput.h ../phonon/../3rdparty/phonon/phonon/addoninterface.h ../phonon/../3rdparty/phonon/phonon/audiooutput.h ../phonon/../3rdparty/phonon/phonon/audiooutputinterface.h ../phonon/../3rdparty/phonon/phonon/backendcapabilities.h ../phonon/../3rdparty/phonon/phonon/backendinterface.h ../phonon/../3rdparty/phonon/phonon/effect.h ../phonon/../3rdparty/phonon/phonon/effectinterface.h ../phonon/../3rdparty/phonon/phonon/effectparameter.h ../phonon/../3rdparty/phonon/phonon/effectwidget.h ../phonon/../3rdparty/phonon/phonon/mediacontroller.h ../phonon/../3rdparty/phonon/phonon/medianode.h ../phonon/../3rdparty/phonon/phonon/mediaobject.h ../phonon/../3rdparty/phonon/phonon/mediaobjectinterface.h ../phonon/../3rdparty/phonon/phonon/mediasource.h ../phonon/../3rdparty/phonon/phonon/objectdescription.h ../phonon/../3rdparty/phonon/phonon/objectdescriptionmodel.h ../phonon/../3rdparty/phonon/phonon/path.h ../phonon/../3rdparty/phonon/phonon/phonon_export.h ../phonon/../3rdparty/phonon/phonon/phonondefs.h ../phonon/../3rdparty/phonon/phonon/phononnamespace.h ../phonon/../3rdparty/phonon/phonon/platformplugin.h ../phonon/../3rdparty/phonon/phonon/seekslider.h ../phonon/../3rdparty/phonon/phonon/streaminterface.h ../phonon/../3rdparty/phonon/phonon/videoplayer.h ../phonon/../3rdparty/phonon/phonon/videowidget.h ../phonon/../3rdparty/phonon/phonon/videowidgetinterface.h ../phonon/../3rdparty/phonon/phonon/volumefadereffect.h ../phonon/../3rdparty/phonon/phonon/volumefaderinterface.h ../phonon/../3rdparty/phonon/phonon/volumeslider.h ../../include/phonon/phonon 
+SYNCQT.HEADER_CLASSES = ../../include/phonon/../Phonon/AbstractAudioOutput ../../include/phonon/../Phonon/AbstractMediaStream ../../include/phonon/../Phonon/AbstractVideoOutput ../../include/phonon/../Phonon/AddonInterface ../../include/phonon/../Phonon/AudioOutput ../../include/phonon/../Phonon/AudioOutputInterface40 ../../include/phonon/../Phonon/AudioOutputInterface42 ../../include/phonon/../Phonon/AudioOutputInterface ../../include/phonon/../Phonon/BackendCapabilities ../../include/phonon/../Phonon/BackendInterface ../../include/phonon/../Phonon/Effect ../../include/phonon/../Phonon/EffectInterface ../../include/phonon/../Phonon/EffectParameter ../../include/phonon/../Phonon/EffectWidget ../../include/phonon/../Phonon/MediaController ../../include/phonon/../Phonon/MediaNode ../../include/phonon/../Phonon/MediaObject ../../include/phonon/../Phonon/MediaObjectInterface ../../include/phonon/../Phonon/MediaSource ../../include/phonon/../Phonon/ObjectDescriptionData ../../include/phonon/../Phonon/ObjectDescription ../../include/phonon/../Phonon/AudioOutputDevice ../../include/phonon/../Phonon/AudioCaptureDevice ../../include/phonon/../Phonon/EffectDescription ../../include/phonon/../Phonon/AudioChannelDescription ../../include/phonon/../Phonon/SubtitleDescription ../../include/phonon/../Phonon/ObjectDescriptionModelData ../../include/phonon/../Phonon/ObjectDescriptionModel ../../include/phonon/../Phonon/AudioOutputDeviceModel ../../include/phonon/../Phonon/AudioCaptureDeviceModel ../../include/phonon/../Phonon/EffectDescriptionModel ../../include/phonon/../Phonon/AudioChannelDescriptionModel ../../include/phonon/../Phonon/SubtitleDescriptionModel ../../include/phonon/../Phonon/Path ../../include/phonon/../Phonon/PlatformPlugin ../../include/phonon/../Phonon/SeekSlider ../../include/phonon/../Phonon/StreamInterface ../../include/phonon/../Phonon/VideoPlayer ../../include/phonon/../Phonon/VideoWidget ../../include/phonon/../Phonon/VideoWidgetInterface ../../include/phonon/../Phonon/VolumeFaderEffect ../../include/phonon/../Phonon/VolumeFaderInterface ../../include/phonon/../Phonon/VolumeSlider 
Index: /trunk/include/phonon/mediacontroller.h
===================================================================
--- /trunk/include/phonon/mediacontroller.h	(revision 560)
+++ /trunk/include/phonon/mediacontroller.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../src/phonon/../3rdparty/phonon/phonon/mediacontroller.h"
Index: /trunk/include/phonon/medianode.h
===================================================================
--- /trunk/include/phonon/medianode.h	(revision 560)
+++ /trunk/include/phonon/medianode.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../src/phonon/../3rdparty/phonon/phonon/medianode.h"
Index: /trunk/include/phonon/mediaobject.h
===================================================================
--- /trunk/include/phonon/mediaobject.h	(revision 560)
+++ /trunk/include/phonon/mediaobject.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../src/phonon/../3rdparty/phonon/phonon/mediaobject.h"
Index: /trunk/include/phonon/mediaobjectinterface.h
===================================================================
--- /trunk/include/phonon/mediaobjectinterface.h	(revision 560)
+++ /trunk/include/phonon/mediaobjectinterface.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../src/phonon/../3rdparty/phonon/phonon/mediaobjectinterface.h"
Index: /trunk/include/phonon/mediasource.h
===================================================================
--- /trunk/include/phonon/mediasource.h	(revision 560)
+++ /trunk/include/phonon/mediasource.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../src/phonon/../3rdparty/phonon/phonon/mediasource.h"
Index: /trunk/include/phonon/objectdescription.h
===================================================================
--- /trunk/include/phonon/objectdescription.h	(revision 560)
+++ /trunk/include/phonon/objectdescription.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../src/phonon/../3rdparty/phonon/phonon/objectdescription.h"
Index: /trunk/include/phonon/objectdescriptionmodel.h
===================================================================
--- /trunk/include/phonon/objectdescriptionmodel.h	(revision 560)
+++ /trunk/include/phonon/objectdescriptionmodel.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../src/phonon/../3rdparty/phonon/phonon/objectdescriptionmodel.h"
Index: /trunk/include/phonon/path.h
===================================================================
--- /trunk/include/phonon/path.h	(revision 560)
+++ /trunk/include/phonon/path.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../src/phonon/../3rdparty/phonon/phonon/path.h"
Index: /trunk/include/phonon/phonon
===================================================================
--- /trunk/include/phonon/phonon	(revision 560)
+++ /trunk/include/phonon/phonon	(revision 560)
@@ -0,0 +1,34 @@
+#ifndef QT_PHONON_MODULE_H
+#define QT_PHONON_MODULE_H
+#include "abstractaudiooutput.h"
+#include "abstractmediastream.h"
+#include "abstractvideooutput.h"
+#include "addoninterface.h"
+#include "audiooutput.h"
+#include "audiooutputinterface.h"
+#include "backendcapabilities.h"
+#include "backendinterface.h"
+#include "effect.h"
+#include "effectinterface.h"
+#include "effectparameter.h"
+#include "effectwidget.h"
+#include "mediacontroller.h"
+#include "medianode.h"
+#include "mediaobject.h"
+#include "mediaobjectinterface.h"
+#include "mediasource.h"
+#include "objectdescription.h"
+#include "objectdescriptionmodel.h"
+#include "path.h"
+#include "phonondefs.h"
+#include "phononnamespace.h"
+#include "platformplugin.h"
+#include "seekslider.h"
+#include "streaminterface.h"
+#include "videoplayer.h"
+#include "videowidget.h"
+#include "videowidgetinterface.h"
+#include "volumefadereffect.h"
+#include "volumefaderinterface.h"
+#include "volumeslider.h"
+#endif
Index: /trunk/include/phonon/phonon_export.h
===================================================================
--- /trunk/include/phonon/phonon_export.h	(revision 560)
+++ /trunk/include/phonon/phonon_export.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../src/phonon/../3rdparty/phonon/phonon/phonon_export.h"
Index: /trunk/include/phonon/phonondefs.h
===================================================================
--- /trunk/include/phonon/phonondefs.h	(revision 560)
+++ /trunk/include/phonon/phonondefs.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../src/phonon/../3rdparty/phonon/phonon/phonondefs.h"
Index: /trunk/include/phonon/phononnamespace.h
===================================================================
--- /trunk/include/phonon/phononnamespace.h	(revision 560)
+++ /trunk/include/phonon/phononnamespace.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../src/phonon/../3rdparty/phonon/phonon/phononnamespace.h"
Index: /trunk/include/phonon/platformplugin.h
===================================================================
--- /trunk/include/phonon/platformplugin.h	(revision 560)
+++ /trunk/include/phonon/platformplugin.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../src/phonon/../3rdparty/phonon/phonon/platformplugin.h"
Index: /trunk/include/phonon/private/abstractaudiooutput_p.h
===================================================================
--- /trunk/include/phonon/private/abstractaudiooutput_p.h	(revision 560)
+++ /trunk/include/phonon/private/abstractaudiooutput_p.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../../src/phonon/../3rdparty/phonon/phonon/abstractaudiooutput_p.h"
Index: /trunk/include/phonon/private/abstractmediastream_p.h
===================================================================
--- /trunk/include/phonon/private/abstractmediastream_p.h	(revision 560)
+++ /trunk/include/phonon/private/abstractmediastream_p.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../../src/phonon/../3rdparty/phonon/phonon/abstractmediastream_p.h"
Index: /trunk/include/phonon/private/abstractvideooutput_p.h
===================================================================
--- /trunk/include/phonon/private/abstractvideooutput_p.h	(revision 560)
+++ /trunk/include/phonon/private/abstractvideooutput_p.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../../src/phonon/../3rdparty/phonon/phonon/abstractvideooutput_p.h"
Index: /trunk/include/phonon/private/audiooutput_p.h
===================================================================
--- /trunk/include/phonon/private/audiooutput_p.h	(revision 560)
+++ /trunk/include/phonon/private/audiooutput_p.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../../src/phonon/../3rdparty/phonon/phonon/audiooutput_p.h"
Index: /trunk/include/phonon/private/audiooutputadaptor_p.h
===================================================================
--- /trunk/include/phonon/private/audiooutputadaptor_p.h	(revision 560)
+++ /trunk/include/phonon/private/audiooutputadaptor_p.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../../src/phonon/../3rdparty/phonon/phonon/audiooutputadaptor_p.h"
Index: /trunk/include/phonon/private/backendcapabilities_p.h
===================================================================
--- /trunk/include/phonon/private/backendcapabilities_p.h	(revision 560)
+++ /trunk/include/phonon/private/backendcapabilities_p.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../../src/phonon/../3rdparty/phonon/phonon/backendcapabilities_p.h"
Index: /trunk/include/phonon/private/effect_p.h
===================================================================
--- /trunk/include/phonon/private/effect_p.h	(revision 560)
+++ /trunk/include/phonon/private/effect_p.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../../src/phonon/../3rdparty/phonon/phonon/effect_p.h"
Index: /trunk/include/phonon/private/effectparameter_p.h
===================================================================
--- /trunk/include/phonon/private/effectparameter_p.h	(revision 560)
+++ /trunk/include/phonon/private/effectparameter_p.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../../src/phonon/../3rdparty/phonon/phonon/effectparameter_p.h"
Index: /trunk/include/phonon/private/effectwidget_p.h
===================================================================
--- /trunk/include/phonon/private/effectwidget_p.h	(revision 560)
+++ /trunk/include/phonon/private/effectwidget_p.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../../src/phonon/../3rdparty/phonon/phonon/effectwidget_p.h"
Index: /trunk/include/phonon/private/factory_p.h
===================================================================
--- /trunk/include/phonon/private/factory_p.h	(revision 560)
+++ /trunk/include/phonon/private/factory_p.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../../src/phonon/../3rdparty/phonon/phonon/factory_p.h"
Index: /trunk/include/phonon/private/frontendinterface_p.h
===================================================================
--- /trunk/include/phonon/private/frontendinterface_p.h	(revision 560)
+++ /trunk/include/phonon/private/frontendinterface_p.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../../src/phonon/../3rdparty/phonon/phonon/frontendinterface_p.h"
Index: /trunk/include/phonon/private/globalconfig_p.h
===================================================================
--- /trunk/include/phonon/private/globalconfig_p.h	(revision 560)
+++ /trunk/include/phonon/private/globalconfig_p.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../../src/phonon/../3rdparty/phonon/phonon/globalconfig_p.h"
Index: /trunk/include/phonon/private/globalstatic_p.h
===================================================================
--- /trunk/include/phonon/private/globalstatic_p.h	(revision 560)
+++ /trunk/include/phonon/private/globalstatic_p.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../../src/phonon/../3rdparty/phonon/phonon/globalstatic_p.h"
Index: /trunk/include/phonon/private/iodevicestream_p.h
===================================================================
--- /trunk/include/phonon/private/iodevicestream_p.h	(revision 560)
+++ /trunk/include/phonon/private/iodevicestream_p.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../../src/phonon/../3rdparty/phonon/phonon/iodevicestream_p.h"
Index: /trunk/include/phonon/private/medianode_p.h
===================================================================
--- /trunk/include/phonon/private/medianode_p.h	(revision 560)
+++ /trunk/include/phonon/private/medianode_p.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../../src/phonon/../3rdparty/phonon/phonon/medianode_p.h"
Index: /trunk/include/phonon/private/medianodedestructionhandler_p.h
===================================================================
--- /trunk/include/phonon/private/medianodedestructionhandler_p.h	(revision 560)
+++ /trunk/include/phonon/private/medianodedestructionhandler_p.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../../src/phonon/../3rdparty/phonon/phonon/medianodedestructionhandler_p.h"
Index: /trunk/include/phonon/private/mediaobject_p.h
===================================================================
--- /trunk/include/phonon/private/mediaobject_p.h	(revision 560)
+++ /trunk/include/phonon/private/mediaobject_p.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../../src/phonon/../3rdparty/phonon/phonon/mediaobject_p.h"
Index: /trunk/include/phonon/private/mediasource_p.h
===================================================================
--- /trunk/include/phonon/private/mediasource_p.h	(revision 560)
+++ /trunk/include/phonon/private/mediasource_p.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../../src/phonon/../3rdparty/phonon/phonon/mediasource_p.h"
Index: /trunk/include/phonon/private/objectdescription_p.h
===================================================================
--- /trunk/include/phonon/private/objectdescription_p.h	(revision 560)
+++ /trunk/include/phonon/private/objectdescription_p.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../../src/phonon/../3rdparty/phonon/phonon/objectdescription_p.h"
Index: /trunk/include/phonon/private/objectdescriptionmodel_p.h
===================================================================
--- /trunk/include/phonon/private/objectdescriptionmodel_p.h	(revision 560)
+++ /trunk/include/phonon/private/objectdescriptionmodel_p.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../../src/phonon/../3rdparty/phonon/phonon/objectdescriptionmodel_p.h"
Index: /trunk/include/phonon/private/path_p.h
===================================================================
--- /trunk/include/phonon/private/path_p.h	(revision 560)
+++ /trunk/include/phonon/private/path_p.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../../src/phonon/../3rdparty/phonon/phonon/path_p.h"
Index: /trunk/include/phonon/private/phonondefs_p.h
===================================================================
--- /trunk/include/phonon/private/phonondefs_p.h	(revision 560)
+++ /trunk/include/phonon/private/phonondefs_p.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../../src/phonon/../3rdparty/phonon/phonon/phonondefs_p.h"
Index: /trunk/include/phonon/private/phononnamespace_p.h
===================================================================
--- /trunk/include/phonon/private/phononnamespace_p.h	(revision 560)
+++ /trunk/include/phonon/private/phononnamespace_p.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../../src/phonon/../3rdparty/phonon/phonon/phononnamespace_p.h"
Index: /trunk/include/phonon/private/platform_p.h
===================================================================
--- /trunk/include/phonon/private/platform_p.h	(revision 560)
+++ /trunk/include/phonon/private/platform_p.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../../src/phonon/../3rdparty/phonon/phonon/platform_p.h"
Index: /trunk/include/phonon/private/qsettingsgroup_p.h
===================================================================
--- /trunk/include/phonon/private/qsettingsgroup_p.h	(revision 560)
+++ /trunk/include/phonon/private/qsettingsgroup_p.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../../src/phonon/../3rdparty/phonon/phonon/qsettingsgroup_p.h"
Index: /trunk/include/phonon/private/seekslider_p.h
===================================================================
--- /trunk/include/phonon/private/seekslider_p.h	(revision 560)
+++ /trunk/include/phonon/private/seekslider_p.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../../src/phonon/../3rdparty/phonon/phonon/seekslider_p.h"
Index: /trunk/include/phonon/private/streaminterface_p.h
===================================================================
--- /trunk/include/phonon/private/streaminterface_p.h	(revision 560)
+++ /trunk/include/phonon/private/streaminterface_p.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../../src/phonon/../3rdparty/phonon/phonon/streaminterface_p.h"
Index: /trunk/include/phonon/private/videowidget_p.h
===================================================================
--- /trunk/include/phonon/private/videowidget_p.h	(revision 560)
+++ /trunk/include/phonon/private/videowidget_p.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../../src/phonon/../3rdparty/phonon/phonon/videowidget_p.h"
Index: /trunk/include/phonon/private/volumefadereffect_p.h
===================================================================
--- /trunk/include/phonon/private/volumefadereffect_p.h	(revision 560)
+++ /trunk/include/phonon/private/volumefadereffect_p.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../../src/phonon/../3rdparty/phonon/phonon/volumefadereffect_p.h"
Index: /trunk/include/phonon/private/volumeslider_p.h
===================================================================
--- /trunk/include/phonon/private/volumeslider_p.h	(revision 560)
+++ /trunk/include/phonon/private/volumeslider_p.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../../src/phonon/../3rdparty/phonon/phonon/volumeslider_p.h"
Index: /trunk/include/phonon/seekslider.h
===================================================================
--- /trunk/include/phonon/seekslider.h	(revision 560)
+++ /trunk/include/phonon/seekslider.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../src/phonon/../3rdparty/phonon/phonon/seekslider.h"
Index: /trunk/include/phonon/streaminterface.h
===================================================================
--- /trunk/include/phonon/streaminterface.h	(revision 560)
+++ /trunk/include/phonon/streaminterface.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../src/phonon/../3rdparty/phonon/phonon/streaminterface.h"
Index: /trunk/include/phonon/videoplayer.h
===================================================================
--- /trunk/include/phonon/videoplayer.h	(revision 560)
+++ /trunk/include/phonon/videoplayer.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../src/phonon/../3rdparty/phonon/phonon/videoplayer.h"
Index: /trunk/include/phonon/videowidget.h
===================================================================
--- /trunk/include/phonon/videowidget.h	(revision 560)
+++ /trunk/include/phonon/videowidget.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../src/phonon/../3rdparty/phonon/phonon/videowidget.h"
Index: /trunk/include/phonon/videowidgetinterface.h
===================================================================
--- /trunk/include/phonon/videowidgetinterface.h	(revision 560)
+++ /trunk/include/phonon/videowidgetinterface.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../src/phonon/../3rdparty/phonon/phonon/videowidgetinterface.h"
Index: /trunk/include/phonon/volumefadereffect.h
===================================================================
--- /trunk/include/phonon/volumefadereffect.h	(revision 560)
+++ /trunk/include/phonon/volumefadereffect.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../src/phonon/../3rdparty/phonon/phonon/volumefadereffect.h"
Index: /trunk/include/phonon/volumefaderinterface.h
===================================================================
--- /trunk/include/phonon/volumefaderinterface.h	(revision 560)
+++ /trunk/include/phonon/volumefaderinterface.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../src/phonon/../3rdparty/phonon/phonon/volumefaderinterface.h"
Index: /trunk/include/phonon/volumeslider.h
===================================================================
--- /trunk/include/phonon/volumeslider.h	(revision 560)
+++ /trunk/include/phonon/volumeslider.h	(revision 560)
@@ -0,0 +1,1 @@
+#include "../../src/phonon/../3rdparty/phonon/phonon/volumeslider.h"